#include <bits/stdc++.h>

using namespace std;
struct interval
{
    long long pocetak;
    long long kraj;
    long long redni;
};
bool cmp(interval a,interval b)
{
    if(a.pocetak<b.pocetak) return true;
    return false;
}
int a[21][200001];

int main()
{
    long long n,m;
    cin>>n>>m;
    vector<long long> donja;
    vector<long long> gornja;
    vector<interval> intervali(n);
    bool p=true;
    for(long long i=0;i<n;i++)
    {
        long long d,u;
        cin>>d>>u;
        if(u>20) p=false;
        donja.push_back(d);
        gornja.push_back(u);
        intervali[i].redni = i+1;
        intervali[i].pocetak = d;
        intervali[i].kraj = u;

    }
    if(n<=1000&&m<=1000)
    {
        for(long long i=0;i<m;i++)
        {
            long long l,r,x;
            cin>>l>>r>>x;
            long long rez=0;
            for(long long i=l-1;i<=r-1;i++)
            {
                if(x>=donja[i]&&x<=gornja[i]) rez++;
            }
            cout<<rez<<endl;
        }

    }
    else if(p)
    {
        for(long long i=1;i<=n;i++)
        {
            for(long long j=donja[i-1];j<=gornja[i-1];j++) a[j][i]=a[j][i-1]+1;
            for(long long j=0;j<donja[i-1];j++) a[j][i]=a[j][i-1];
            for(long long j=gornja[i-1]+1;j<21;j++) a[j][i]=a[j][i-1];
        }
        for(long long i=0;i<m;i++)
        {
            long long l,r,x;
            cin>>l>>r>>x;
            cout<<a[x][r]-a[x][l-1]<<endl;
        }
    }
    else
    {
        sort(intervali.begin(),intervali.end(),cmp);
        vector<long long> poceci(n);
        vector<long long> krajevi(n);
        for(long long i=0;i<n;i++)
        {
            poceci[i]=intervali[i].pocetak;
            krajevi[i]=intervali[i].kraj;
        }
        for(long long i=0;i<m;i++)
        {
            long long l,r,x;
            cin>>l>>r>>x;
            auto it = upper_bound(poceci.begin(),poceci.end(),x);
            long long w;
            if(it==poceci.end()) w=n;
            else  w = it - poceci.begin();
            if(x<=krajevi[w-1]&&intervali[w-1].redni<=r&&intervali[w-1].redni>=l) cout<<1<<endl;
            else cout<<0<<endl;
        }
    }
}